/**
 *		Ar-Du Processing code
 * 		By: Fizikus
 *  		19/06/2012
 */
 
import processing.serial.*;
import java.io.File;

Serial myPort;
int i = 1;

String ImageFilename = dataPath("Kep.jpg"); 
int CharE = 69;
int CharO = 79;
int CharF = 70;
int TotalBytes = 0;
Boolean imageLoading = false;
Boolean imageReceived = false;
Boolean firstPicture = true;
PImage cameraImg;

byte[] Photo = {
};

ImageButtons button1, button2, button3, button4, button5, button6, button7, button8, button9, button10;
ImageButtons button11, button12, button13;

void setup()
{
  size(950, 600);
  background(255, 255, 255);
  
  // Define and create image buttons
  PImage b1 = loadImage("seb1.JPG");
  PImage r1 = loadImage("seb1on.JPG");
  PImage b2 = loadImage("seb2.JPG");
  PImage r2 = loadImage("seb2on.JPG");
  PImage b3 = loadImage("seb3.JPG");
  PImage r3 = loadImage("seb3on.JPG");
  PImage b4 = loadImage("balra.JPG");
  PImage r4 = loadImage("balraon.JPG");
  PImage b5 = loadImage("jobbra.JPG");
  PImage r5 = loadImage("jobbraon.JPG");
  PImage b6 = loadImage("elore.JPG");
  PImage r6 = loadImage("eloreon.JPG");
  PImage b7 = loadImage("hatra.JPG");
  PImage r7 = loadImage("hatraon.JPG");
  PImage b8 = loadImage("stop.JPG");
  PImage r8 = loadImage("stopon.JPG");
  PImage b9 = loadImage("kamera.JPG");
  PImage r9 = loadImage("kameraon.JPG");
  PImage b10 = loadImage("fejbal.JPG");
  PImage r10 = loadImage("fejbalon.JPG");
  PImage b11 = loadImage("fejjobb.JPG");
  PImage r11 = loadImage("fejjobbon.JPG");
  PImage b12 = loadImage("fejelore.JPG");
  PImage r12 = loadImage("fejeloreon.JPG");
  PImage b13 = loadImage("hang.JPG");
  PImage r13 = loadImage("hangon.JPG");
  PImage einstein = loadImage("einstein.JPG");
  image(einstein,10,115);
// set speed to 60%
  button1 = new ImageButtons(50, 5, 102, 105, b1, r1, b1); 
// set speed to 80%
  button2 = new ImageButtons(170, 5, 131, 105, b2, r2, b2); 
// set speed to 100%
  button3 = new ImageButtons(320, 5, 164, 105, b3, r3, b3);
// turn left  
  button4 = new ImageButtons(675, 95, 74, 85, b4, r4, b4);   
// turn right
button5 = new ImageButtons(865, 95, 74, 85, b5, r5, b5);
// forward
  button6 = new ImageButtons(765, 10, 85, 74, b6, r6, b6);
// backward
  button7 = new ImageButtons(765, 190, 85, 74, b7, r7, b7);
// stop
  button8 = new ImageButtons(765, 95, 85, 85, b8, r8, b8); 
// take photo
  button9 = new ImageButtons(760, 450, 102, 102, b9, r9, b9); 
// look left
  button10 = new ImageButtons(680, 440, 68, 61, b10, r10, b10);
// look right
  button11 = new ImageButtons(870, 440, 68, 61, b11, r11, b11);
// look forward
  button12 = new ImageButtons(775, 370, 68, 61, b12, r12, b12);
// sound
  button13 = new ImageButtons(550, 10, 98, 80, b13, r13, b13); 

  //Set and open serial port
  myPort = new Serial( this, Serial.list()[0], 115200 );
  myPort.clear();
}

void draw()
{
    button1.update();
    button1.display();
    button2.update();
    button2.display();
    button3.update();
    button3.display();
    button4.update();
    button4.display();
    button5.update();
    button5.display();
    button6.update();
    button6.display();
    button7.update();
    button7.display();
    button8.update();
    button8.display();
    button9.update();
    button9.display();
    button10.update();
    button10.display();
    button11.update();
    button11.display();
    button12.update();
    button12.display();
    button13.update();
    button13.display();
  
    // Import Picture
 if(imageLoading)
  {
    loadPhoto(); // must be polled every time
  }
  else if(imageReceived) 
  {
    image(cameraImg, 10, 115, width*0.68, height*0.8);
  }
}

void mousePressed() 
  {
    if(button1.pressed()) {
      myPort.write('1');
      //println("set speed to 60%");
    } 
    else if(button2.pressed()) {
      myPort.write('2');
      //println("set speed to 80%");
    } 
    else if(button3.pressed()) {
      myPort.write('3');
      //println("set speed to 100%");
    } 
    else if(button4.pressed()) {
      myPort.write('b');
      //println("left");
    } 
    else if(button5.pressed()) {
      myPort.write('j');
      //println("right");
    }
    else if(button6.pressed()) {
      myPort.write('e');
      //println("forward");
    } 
    else if(button7.pressed()) {
      myPort.write('h');
      //println("backward");
    } 
    else if(button8.pressed()) {
      myPort.write('s');
      //println("stop");
    } 
    else if(button9.pressed()) {
      captureAndSend();
      //println("photo");
    }
    else if(button10.pressed()) {
      myPort.write('a');
      //println("look left");
    } 
    else if(button11.pressed()) {
      myPort.write('d');
      //println("look right");
    } 
    else if(button12.pressed()) {
      myPort.write('w');
      //println("look forward");
    } 
    else if(button13.pressed()) {
      myPort.write('v');
      //println("sound");
    }
  }

class Button
{
  int x, y;
  int w, h;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;  
 
   boolean pressed() {
    if(over && mousePressed) {
      //pressed = true;
      return true;
    } else {
      //pressed = false;
      return false;
    }    
  }
  
  boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;

  ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
  }
  
  void update() 
  {
    over();
    pressed();
    if(pressed) {
      currentimage = down;
    } else if (over){
      currentimage = roll;
    } else {
      currentimage = base;
    }
  }   
  
  void over() 
  {
    if( overRect(x, y, w, h) ) {
      over = true;
      //return true;
    } else {
      over = false;
      //return false;
    }
  } 
  
  void display() 
  {
    image(currentimage, x, y);
  }
}

void loadPhoto() 
{
  byte[] buffer = new byte[64];
  while( myPort.available() > 0 )
  {
    int readBytes = myPort.readBytes(buffer);
    for( int i = 0; i < readBytes; i++ )
    {
      TotalBytes = TotalBytes + 1;
      Photo = append( Photo, buffer[i] );
      if ( TotalBytes > 2 && Photo[TotalBytes-3] == CharE && Photo[TotalBytes-2] == CharO && Photo[TotalBytes-1] == CharF ) 
      {
        // Save picture to file
        if( Photo.length > 10 && !imageReceived ) 
        {  
          File dataFile = sketchFile(ImageFilename);
        
          if (dataFile.exists())
          {
            dataFile.delete();
          }
          
          saveBytes(ImageFilename, Photo);
      
          cameraImg = loadImage(ImageFilename);
  
          imageReceived = true;
          imageLoading = false;
          
          Photo = null; // clear array
    
          //Clear totalbytes
          TotalBytes = 0;

          //Flush serial port
          myPort.clear();
          println("EoF");
          return;
        }
      }
    }
  }
}


void captureAndSend() 
{
  imageReceived = false;
  imageLoading = true;
  Photo = new byte[0];
  TotalBytes = 0;
  myPort.write('k');
}


